//---------------------------------------------------------------------------
//
// Fonction de synchro
//
//---------------------------------------------------------------------------

#include "Osc.h"

//---------------------------------------------------------------------------
// Thread Synchro
//---------------------------------------------------------------------------

DWORD __stdcall TFenetre::Thread_Sync(LPVOID lpParam) {

HANDLE hEvents[5];
DWORD event;
bool fini = false;

while(!fini) {
        hEvents[0]=Fenetre->Event[STOP_SYN];
        //on attend la fin du thread synchro
        hEvents[1]=Fenetre->Event[INIT_CARTE];
        //Init la carte
        hEvents[2]=Fenetre->Event[AFFICH_VALS];
        //Commence de lire les valeurs
        hEvents[3]=Fenetre->Event[CHANGE_CAL];
        //Change les calibres
        hEvents[4]=Fenetre->Event[TRIG_ON];
        //Active le trigger

        event = WaitForMultipleObjects(5,hEvents,FALSE,INFINITE);
        switch(event) {
        case WAIT_OBJECT_0:
                //fin du thread, arrete les 2 autres
                SetEvent(Fenetre->Event[STOP_ECR]);
                SetEvent(Fenetre->Event[STOP_LEC]);
                fini = true;
                break;

        case WAIT_OBJECT_0+1:
                //initialise la carte
                Fenetre->StatusBar->SimpleText = " Port de communication ferm";
                if(Fenetre->InitCarte())
                {Fenetre->StatusBar->SimpleText = " Carte initialise sur le port "+Fenetre->PortComChoix->Text+" :)";}
                else {
                Fenetre->StatusBar->SimpleText = " La carte agonise, ou elle ne rpond pas...";
                Fenetre->Ouvre_Com->Enabled=true;}
                break;

        case WAIT_OBJECT_0+2:
                //Lit les valeurs
                if(Fenetre->carte_ok) {
                Fenetre->lit_vals = true;
                if(!Fenetre->Lecture())
                Fenetre->ErreurreuIO(); }
                break;

        case WAIT_OBJECT_0+3:
                //Change les calibres
                if(Fenetre->carte_ok)
                Fenetre->Change_Cals();
                break;

        case WAIT_OBJECT_0+4:
                //Change les calibres
                if(Fenetre->carte_ok)
                if(!Fenetre->TriggerOn())
                Fenetre->ErreurreuIO();
                else SetEvent(Fenetre->Event[AFFICH_OK]);
                break;

        }// fin switch
} //fin boucle infinie ;)

SetEvent(Fenetre->Event[TH_SYN_FINI]);
//fin du thread synch
return 0;
}

//---------------------------------------------------------------------------
// Initialisation de la carte
//---------------------------------------------------------------------------

bool TFenetre::InitCarte(void)  {
//il y a un debut  tout, meme aux ours polaires

//char tmp;

Lec_TimeOut = 500;

//si il ya deja qqch d'ouvert, on le ferme
Ouvre_Com->Enabled=false;


//ferme le port
if(hPortSerie != INVALID_HANDLE_VALUE) CloseHandle(hPortSerie);
//Necessaire pr windows
Sleep(100);

//on ouvre le nouveau port
strcpy(com_port,static_cast<const char*>(PortComChoix->Text.data()));
hPortSerie=CreateFile(com_port,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,
FILE_FLAG_OVERLAPPED,NULL);


if(hPortSerie == INVALID_HANDLE_VALUE) {
MessageBox(NULL,"Pb  l'ouverture du port serie","Pb !",0);
return false;
}

dcb.BaudRate=115200;
dcb.ByteSize=8;
dcb.Parity=NOPARITY;
dcb.StopBits=ONESTOPBIT;

if(!SetCommState(hPortSerie,&dcb)) {
MessageBox(NULL,"Pb pdt config du port serie","Pb !",0);
return false;
}

EscapeCommFunction(hPortSerie,SETRTS); //reset la carte
Sleep(100);
EscapeCommFunction(hPortSerie,CLRRTS);
Sleep(200);


if(!Ecrit('O')) return false;
if(Commande('K') != 'O') return false;

carte_ok = true;
lit_vals = true;
SetEvent(Event[AFFICH_VALS]);
TmpDiv->Enabled = true;
VDiv->Enabled = true;
return true;
}

//---------------------------------------------------------------------------
// Lecture
//---------------------------------------------------------------------------

bool TFenetre::Lecture()  {

HANDLE hEvents[2];
int nb;
int i = 0;

Lec_TimeOut = 3000;
while(lit_vals) {
        nb = ModeTmp[tmp_div].nb_a_lire;
        if(!Lit_Vals(nb)) return false;
        hEvents[0]=Fenetre->mutex_aff;    //fin du prgm
        hEvents[1]=Fenetre->mutex_lec;   //ordre d'afficher
        WaitForMultipleObjects(2,hEvents,TRUE,INFINITE);

        for(int j=1;j<nb+1;j++)
        buffer_a[i+j]=buffer_l[j];
        i+=nb;
        if(i>=N/2) i=0;

        ReleaseMutex(mutex_aff);
        ReleaseMutex(mutex_lec);
        SetEvent(Event[AFFICH_OK]);
}

return true;
}

//---------------------------------------------------------------------------
// Change les calibres
//---------------------------------------------------------------------------

void TFenetre::Change_Cals()  {
        tmp_div = TmpDiv->ItemIndex;
        v_div = VDiv->ItemIndex;



        LabelY0->Caption = "0 V";
        LabelY1->Caption =  FloatToStrF(64*ModeV[v_div].div,ffFixed,4,2)+" V";
        LabelYM1->Caption =  FloatToStrF(-64*ModeV[v_div].div,ffFixed,4,2)+" V";;


        lit_vals = true;
        SetEvent(Fenetre->Event[AFFICH_VALS]);
}

//---------------------------------------------------------------------------
// Vive les petits herissons ! :)
//---------------------------------------------------------------------------

bool TFenetre::TriggerOn()  {
//trig

HANDLE hEvents[2];

if(ModeTmp[tmp_div].nb_a_lire != N) return true;

Lec_TimeOut = INFINITE;

if(!Trig_Vals()) return false;
hEvents[0]=Fenetre->mutex_aff;    //fin du prgm
hEvents[1]=Fenetre->mutex_lec;   //ordre d'afficher
WaitForMultipleObjects(2,hEvents,TRUE,INFINITE);

for(int j=1;j<N+1;j++)
buffer_a[j]=buffer_l[j+1];

ReleaseMutex(mutex_aff);
ReleaseMutex(mutex_lec);
SetEvent(Event[AFFICH_OK]);

return true;
}

//---------------------------------------------------------------------------
// Erreur IO
//---------------------------------------------------------------------------

void TFenetre::ErreurreuIO()  {
carte_ok = false;
trigger_on  = false;
ButtonTrig->Caption = "Activer Trigger";
TmpDiv->Enabled = false;
VDiv->Enabled = false;
Ouvre_Com->Enabled = true;
Fenetre->StatusBar->SimpleText = " Erreur avec la carte :(";
if(MessageBox(NULL,"Erreur pendant la communication avec la carte","Pb !",MB_RETRYCANCEL)==IDRETRY)
SetEvent(Event[INIT_CARTE]);
}





